<?php
/**
 * ContactsApi
 * PHP version 5
 *
 * @category Class
 * @package  MailMojo
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * MailMojo API
 *
 * v1 of the MailMojo API
 *
 * OpenAPI spec version: 1.0.0
 * Contact: hjelp@mailmojo.no
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace MailMojo\Api;

use \MailMojo\Configuration;
use \MailMojo\ApiClient;
use \MailMojo\ApiException;
use \MailMojo\ObjectSerializer;

/**
 * ContactsApi Class Doc Comment
 *
 * @category Class
 * @package  MailMojo
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class ContactsApi
{

    /**
     * API Client
     *
     * @var \MailMojo\ApiClient instance of the ApiClient
     */
    protected $apiClient;

    /**
     * Constructor
     *
     * @param \MailMojo\ApiClient|null $apiClient The api client to use
     */
    public function __construct(\MailMojo\ApiClient $apiClient = null)
    {
        if ($apiClient == null) {
            $apiClient = new ApiClient();
            $apiClient->getConfig()->setHost('https://api.mailmojo.no/v1');
        }

        $this->apiClient = $apiClient;
    }

    /**
     * Get API client
     *
     * @return \MailMojo\ApiClient get the API client
     */
    public function getApiClient()
    {
        return $this->apiClient;
    }

    /**
     * Set the API client
     *
     * @param \MailMojo\ApiClient $apiClient set the API client
     *
     * @return ContactsApi
     */
    public function setApiClient(\MailMojo\ApiClient $apiClient)
    {
        $this->apiClient = $apiClient;
        return $this;
    }

    /**
     * Operation getContacts
     *
     * Retrieve all contacts across every list.
     *
     * @return \MailMojo\Model\Contact[]
     * @throws \MailMojo\ApiException on non-2xx response
     */
    public function getContacts()
    {
        list($response) = $this->getContactsWithHttpInfo();
        return $response;
    }

    /**
     * Operation getContactsWithHttpInfo
     *
     * Retrieve all contacts across every list.
     *
     * @return Array of \MailMojo\Model\Contact[], HTTP status code, HTTP response headers (array of strings)
     * @throws \MailMojo\ApiException on non-2xx response
     */
    public function getContactsWithHttpInfo()
    {
        // parse inputs
        $resourcePath = "/contacts/";
        $httpBody = '';
        $queryParams = array();
        $headerParams = array();
        $formParams = array();
        $_header_accept = $this->apiClient->selectHeaderAccept(array('application/json'));
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(array('application/json'));

        // default format to json
        $resourcePath = str_replace("{format}", "json", $resourcePath);

        
        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires OAuth (access token)
        if (strlen($this->apiClient->getConfig()->getAccessToken()) !== 0) {
            $headerParams['Authorization'] = 'Bearer ' . $this->apiClient->getConfig()->getAccessToken();
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\MailMojo\Model\Contact[]',
                '/contacts/'
            );

            return array($this->apiClient->getSerializer()->deserialize($response, '\MailMojo\Model\Contact[]', $httpHeader), $statusCode, $httpHeader);
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\MailMojo\Model\Contact[]', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation getSubscriberOnListByEmail
     *
     * Retrieve a subscriber.
     *
     * @param int $list_id ID of the email list to retrieve the subscriber from. (required)
     * @param string $email Email address of the contact to retrieve. (required)
     * @return \MailMojo\Model\Subscriber[]
     * @throws \MailMojo\ApiException on non-2xx response
     */
    public function getSubscriberOnListByEmail($list_id, $email)
    {
        list($response) = $this->getSubscriberOnListByEmailWithHttpInfo($list_id, $email);
        return $response;
    }

    /**
     * Operation getSubscriberOnListByEmailWithHttpInfo
     *
     * Retrieve a subscriber.
     *
     * @param int $list_id ID of the email list to retrieve the subscriber from. (required)
     * @param string $email Email address of the contact to retrieve. (required)
     * @return Array of \MailMojo\Model\Subscriber[], HTTP status code, HTTP response headers (array of strings)
     * @throws \MailMojo\ApiException on non-2xx response
     */
    public function getSubscriberOnListByEmailWithHttpInfo($list_id, $email)
    {
        // verify the required parameter 'list_id' is set
        if ($list_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $list_id when calling getSubscriberOnListByEmail');
        }
        // verify the required parameter 'email' is set
        if ($email === null) {
            throw new \InvalidArgumentException('Missing the required parameter $email when calling getSubscriberOnListByEmail');
        }
        // parse inputs
        $resourcePath = "/lists/{list_id}/subscribers/{email}/";
        $httpBody = '';
        $queryParams = array();
        $headerParams = array();
        $formParams = array();
        $_header_accept = $this->apiClient->selectHeaderAccept(array('application/json'));
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(array('application/json'));

        // path params
        if ($list_id !== null) {
            $resourcePath = str_replace(
                "{" . "list_id" . "}",
                $this->apiClient->getSerializer()->toPathValue($list_id),
                $resourcePath
            );
        }
        // path params
        if ($email !== null) {
            $resourcePath = str_replace(
                "{" . "email" . "}",
                $this->apiClient->getSerializer()->toPathValue($email),
                $resourcePath
            );
        }
        // default format to json
        $resourcePath = str_replace("{format}", "json", $resourcePath);

        
        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires OAuth (access token)
        if (strlen($this->apiClient->getConfig()->getAccessToken()) !== 0) {
            $headerParams['Authorization'] = 'Bearer ' . $this->apiClient->getConfig()->getAccessToken();
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\MailMojo\Model\Subscriber[]',
                '/lists/{list_id}/subscribers/{email}/'
            );

            return array($this->apiClient->getSerializer()->deserialize($response, '\MailMojo\Model\Subscriber[]', $httpHeader), $statusCode, $httpHeader);
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\MailMojo\Model\Subscriber[]', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation getSubscribersOnList
     *
     * Retrieve subscribers on a list.
     *
     * @param int $list_id ID of the email list. (required)
     * @return \MailMojo\Model\Subscriber[]
     * @throws \MailMojo\ApiException on non-2xx response
     */
    public function getSubscribersOnList($list_id)
    {
        list($response) = $this->getSubscribersOnListWithHttpInfo($list_id);
        return $response;
    }

    /**
     * Operation getSubscribersOnListWithHttpInfo
     *
     * Retrieve subscribers on a list.
     *
     * @param int $list_id ID of the email list. (required)
     * @return Array of \MailMojo\Model\Subscriber[], HTTP status code, HTTP response headers (array of strings)
     * @throws \MailMojo\ApiException on non-2xx response
     */
    public function getSubscribersOnListWithHttpInfo($list_id)
    {
        // verify the required parameter 'list_id' is set
        if ($list_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $list_id when calling getSubscribersOnList');
        }
        // parse inputs
        $resourcePath = "/lists/{list_id}/subscribers/";
        $httpBody = '';
        $queryParams = array();
        $headerParams = array();
        $formParams = array();
        $_header_accept = $this->apiClient->selectHeaderAccept(array('application/json'));
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(array('application/json'));

        // path params
        if ($list_id !== null) {
            $resourcePath = str_replace(
                "{" . "list_id" . "}",
                $this->apiClient->getSerializer()->toPathValue($list_id),
                $resourcePath
            );
        }
        // default format to json
        $resourcePath = str_replace("{format}", "json", $resourcePath);

        
        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires OAuth (access token)
        if (strlen($this->apiClient->getConfig()->getAccessToken()) !== 0) {
            $headerParams['Authorization'] = 'Bearer ' . $this->apiClient->getConfig()->getAccessToken();
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\MailMojo\Model\Subscriber[]',
                '/lists/{list_id}/subscribers/'
            );

            return array($this->apiClient->getSerializer()->deserialize($response, '\MailMojo\Model\Subscriber[]', $httpHeader), $statusCode, $httpHeader);
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\MailMojo\Model\Subscriber[]', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation importSubscribersToList
     *
     * Subscribe contacts to the email list.
     *
     * @param int $list_id ID of the email list to subscribe to. (required)
     * @param \MailMojo\Model\Contacts[] $contacts  (optional)
     * @return \MailMojo\Model\ImportResult
     * @throws \MailMojo\ApiException on non-2xx response
     */
    public function importSubscribersToList($list_id, $contacts = null)
    {
        list($response) = $this->importSubscribersToListWithHttpInfo($list_id, $contacts);
        return $response;
    }

    /**
     * Operation importSubscribersToListWithHttpInfo
     *
     * Subscribe contacts to the email list.
     *
     * @param int $list_id ID of the email list to subscribe to. (required)
     * @param \MailMojo\Model\Contacts[] $contacts  (optional)
     * @return Array of \MailMojo\Model\ImportResult, HTTP status code, HTTP response headers (array of strings)
     * @throws \MailMojo\ApiException on non-2xx response
     */
    public function importSubscribersToListWithHttpInfo($list_id, $contacts = null)
    {
        // verify the required parameter 'list_id' is set
        if ($list_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $list_id when calling importSubscribersToList');
        }
        // parse inputs
        $resourcePath = "/lists/{list_id}/subscribers/import/";
        $httpBody = '';
        $queryParams = array();
        $headerParams = array();
        $formParams = array();
        $_header_accept = $this->apiClient->selectHeaderAccept(array('application/json'));
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(array('text/csv'));

        // path params
        if ($list_id !== null) {
            $resourcePath = str_replace(
                "{" . "list_id" . "}",
                $this->apiClient->getSerializer()->toPathValue($list_id),
                $resourcePath
            );
        }
        // default format to json
        $resourcePath = str_replace("{format}", "json", $resourcePath);

        // body params
        $_tempBody = null;
        if (isset($contacts)) {
            $_tempBody = $contacts;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires OAuth (access token)
        if (strlen($this->apiClient->getConfig()->getAccessToken()) !== 0) {
            $headerParams['Authorization'] = 'Bearer ' . $this->apiClient->getConfig()->getAccessToken();
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\MailMojo\Model\ImportResult',
                '/lists/{list_id}/subscribers/import/'
            );

            return array($this->apiClient->getSerializer()->deserialize($response, '\MailMojo\Model\ImportResult', $httpHeader), $statusCode, $httpHeader);
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\MailMojo\Model\ImportResult', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), 'object', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation subscribeContactToList
     *
     * Subscribe a contact to the email list.
     *
     * @param int $list_id ID of the email list to subscribe to. (required)
     * @param \MailMojo\Model\Contact $contact  (optional)
     * @return \MailMojo\Model\Contact
     * @throws \MailMojo\ApiException on non-2xx response
     */
    public function subscribeContactToList($list_id, $contact = null)
    {
        list($response) = $this->subscribeContactToListWithHttpInfo($list_id, $contact);
        return $response;
    }

    /**
     * Operation subscribeContactToListWithHttpInfo
     *
     * Subscribe a contact to the email list.
     *
     * @param int $list_id ID of the email list to subscribe to. (required)
     * @param \MailMojo\Model\Contact $contact  (optional)
     * @return Array of \MailMojo\Model\Contact, HTTP status code, HTTP response headers (array of strings)
     * @throws \MailMojo\ApiException on non-2xx response
     */
    public function subscribeContactToListWithHttpInfo($list_id, $contact = null)
    {
        // verify the required parameter 'list_id' is set
        if ($list_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $list_id when calling subscribeContactToList');
        }
        // parse inputs
        $resourcePath = "/lists/{list_id}/subscribers/";
        $httpBody = '';
        $queryParams = array();
        $headerParams = array();
        $formParams = array();
        $_header_accept = $this->apiClient->selectHeaderAccept(array('application/json'));
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(array('application/json'));

        // path params
        if ($list_id !== null) {
            $resourcePath = str_replace(
                "{" . "list_id" . "}",
                $this->apiClient->getSerializer()->toPathValue($list_id),
                $resourcePath
            );
        }
        // default format to json
        $resourcePath = str_replace("{format}", "json", $resourcePath);

        // body params
        $_tempBody = null;
        if (isset($contact)) {
            $_tempBody = $contact;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires OAuth (access token)
        if (strlen($this->apiClient->getConfig()->getAccessToken()) !== 0) {
            $headerParams['Authorization'] = 'Bearer ' . $this->apiClient->getConfig()->getAccessToken();
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\MailMojo\Model\Contact',
                '/lists/{list_id}/subscribers/'
            );

            return array($this->apiClient->getSerializer()->deserialize($response, '\MailMojo\Model\Contact', $httpHeader), $statusCode, $httpHeader);
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 201:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\MailMojo\Model\Contact', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), 'object', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation unsubscribeContactOnListByEmail
     *
     * Unsubscribe a contact.
     *
     * @param int $list_id ID of the email list to unsubscribe from. (required)
     * @param string $email Email address of the contact to unsubscribe. (required)
     * @return \MailMojo\Model\Contact
     * @throws \MailMojo\ApiException on non-2xx response
     */
    public function unsubscribeContactOnListByEmail($list_id, $email)
    {
        list($response) = $this->unsubscribeContactOnListByEmailWithHttpInfo($list_id, $email);
        return $response;
    }

    /**
     * Operation unsubscribeContactOnListByEmailWithHttpInfo
     *
     * Unsubscribe a contact.
     *
     * @param int $list_id ID of the email list to unsubscribe from. (required)
     * @param string $email Email address of the contact to unsubscribe. (required)
     * @return Array of \MailMojo\Model\Contact, HTTP status code, HTTP response headers (array of strings)
     * @throws \MailMojo\ApiException on non-2xx response
     */
    public function unsubscribeContactOnListByEmailWithHttpInfo($list_id, $email)
    {
        // verify the required parameter 'list_id' is set
        if ($list_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $list_id when calling unsubscribeContactOnListByEmail');
        }
        // verify the required parameter 'email' is set
        if ($email === null) {
            throw new \InvalidArgumentException('Missing the required parameter $email when calling unsubscribeContactOnListByEmail');
        }
        // parse inputs
        $resourcePath = "/lists/{list_id}/subscribers/{email}/";
        $httpBody = '';
        $queryParams = array();
        $headerParams = array();
        $formParams = array();
        $_header_accept = $this->apiClient->selectHeaderAccept(array('application/json'));
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(array('application/json'));

        // path params
        if ($list_id !== null) {
            $resourcePath = str_replace(
                "{" . "list_id" . "}",
                $this->apiClient->getSerializer()->toPathValue($list_id),
                $resourcePath
            );
        }
        // path params
        if ($email !== null) {
            $resourcePath = str_replace(
                "{" . "email" . "}",
                $this->apiClient->getSerializer()->toPathValue($email),
                $resourcePath
            );
        }
        // default format to json
        $resourcePath = str_replace("{format}", "json", $resourcePath);

        
        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires OAuth (access token)
        if (strlen($this->apiClient->getConfig()->getAccessToken()) !== 0) {
            $headerParams['Authorization'] = 'Bearer ' . $this->apiClient->getConfig()->getAccessToken();
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'DELETE',
                $queryParams,
                $httpBody,
                $headerParams,
                '\MailMojo\Model\Contact',
                '/lists/{list_id}/subscribers/{email}/'
            );

            return array($this->apiClient->getSerializer()->deserialize($response, '\MailMojo\Model\Contact', $httpHeader), $statusCode, $httpHeader);
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\MailMojo\Model\Contact', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

}
