MailMojo SDK for PHP
====================
v1 of the MailMojo API

This package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 0.1.0
- Build date: 2016-12-16T12:28:46.018+01:00

For more information, please visit [https://mailmojo.gelato.io](https://mailmojo.gelato.io)

## Requirements

PHP 5.4.0 and later

## Installation & Usage
### Composer

To install the bindings via [Composer](http://getcomposer.org/), add the following to `composer.json`:

```
{
  "require": {
    "eliksir/mailmojo-php-sdk": "0.1.0"
  }
}
```

Then run `composer install`

### Manual Installation

Download the files and include `autoload.php`:

```php
    require_once('/path/to/mailmojo/autoload.php');
```

## Tests

To run the unit tests:

```
composer install
./vendor/bin/phpunit
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: mailmojo_auth
MailMojo\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new MailMojo\Api\ListsApi();
$list_id = 56; // int | ID of the email list to retrieve.

try {
    $result = $api_instance->updateList($list_id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ListsApi->updateList: ', $e->getMessage(), PHP_EOL;
}

?>
```

## Documentation for API Endpoints

All URIs are relative to *https://api.mailmojo.no/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AccountsApi* | [**createAccount**](docs/Api/AccountsApi.md#createaccount) | **POST** /accounts/ | Create an account.
*AccountsApi* | [**getAccountByUsername**](docs/Api/AccountsApi.md#getaccountbyusername) | **GET** /accounts/{username}/ | Retrieve account details.
*AccountsApi* | [**updateAccount**](docs/Api/AccountsApi.md#updateaccount) | **POST** /accounts/{username}/ | Update account details.
*ContactsApi* | [**getContacts**](docs/Api/ContactsApi.md#getcontacts) | **GET** /contacts/ | Retrieve all contacts across every list.
*ContactsApi* | [**getSubscriberOnListByEmail**](docs/Api/ContactsApi.md#getsubscriberonlistbyemail) | **GET** /lists/{list_id}/subscribers/{email}/ | Retrieve a subscriber.
*ContactsApi* | [**getSubscribersOnList**](docs/Api/ContactsApi.md#getsubscribersonlist) | **GET** /lists/{list_id}/subscribers/ | Retrieve subscribers on a list.
*ContactsApi* | [**importSubscribersToList**](docs/Api/ContactsApi.md#importsubscriberstolist) | **POST** /lists/{list_id}/subscribers/import/ | Subscribe contacts to the email list.
*ContactsApi* | [**subscribeContactToList**](docs/Api/ContactsApi.md#subscribecontacttolist) | **POST** /lists/{list_id}/subscribers/ | Subscribe a contact to the email list.
*ContactsApi* | [**unsubscribeContactOnListByEmail**](docs/Api/ContactsApi.md#unsubscribecontactonlistbyemail) | **DELETE** /lists/{list_id}/subscribers/{email}/ | Unsubscribe a contact.
*EmbedApi* | [**createEmbedSession**](docs/Api/EmbedApi.md#createembedsession) | **POST** /embed/ | Create a new embedded application session.
*ListsApi* | [**getListById**](docs/Api/ListsApi.md#getlistbyid) | **GET** /lists/{list_id}/ | Retrieve an email list.
*ListsApi* | [**getLists**](docs/Api/ListsApi.md#getlists) | **GET** /lists/ | Retrieve all email lists.
*ListsApi* | [**updateList**](docs/Api/ListsApi.md#updatelist) | **PATCH** /lists/{list_id}/ | Update an email list partially.


## Documentation For Models

 - [Contact](docs/Model/Contact.md)
 - [ContactListAssociations](docs/Model/ContactListAssociations.md)
 - [Contacts](docs/Model/Contacts.md)
 - [Embed](docs/Model/Embed.md)
 - [EmbedOptions](docs/Model/EmbedOptions.md)
 - [ImportResult](docs/Model/ImportResult.md)
 - [MinimalUser](docs/Model/MinimalUser.md)
 - [ModelList](docs/Model/ModelList.md)
 - [Subscriber](docs/Model/Subscriber.md)
 - [User](docs/Model/User.md)


## Documentation For Authorization


## mailmojo_auth

- **Type**: OAuth
- **Flow**: accessCode
- **Authorization URL**: https://api.mailmojo.no/oauth/authorize/
- **Scopes**: 
 - **account**: Manage your MailMojo account.
 - **account_creation**: Create new MailMojo accounts.
 - **account_creation.trial_30**: Create new MailMojo accounts with a 30 day trial period.
 - **contacts**: Manage your contacts across all your email lists.
 - **contacts:read**: Retrieve your contacts across all your email lists.
 - **embed**: Give you an embedded MailMojo application with access to your account.
 - **lists**: Manage your email lists, excluding subscribers.
 - **lists:read**: Retrieve your email lists, excluding subscribers.


## Author

hjelp@mailmojo.no

